<?php

namespace App\Service;


use App\Model\BigKingCbj;

class LabelDealService extends Service
{
    protected static $instance;

    public static function getInstance(): self
    {
        if (self::$instance == null) self::$instance = new LabelDealService();
        return self::$instance;
    }

    public function clearData($data,&$return,&$box_list){
        if( empty($data['lead_out']) || empty($data['lead_out']['brand_out_stock_list'])) return;

        foreach ($data['lead_out']['brand_out_stock_list'] as $value){
            $tmp = $value['brand_out_stock_dtl'];
            $return[$value['send_box_code']] = [
                'fake_qty' => $tmp['fake_qty'],
                'detail' => explode(',',$tmp['brand_qr_code_list'])
            ];
            $box_list[] = $value['send_box_code'];
        }
    }

    public function boxOut($data,$token,$result,$id)
    {
        //商标绑定
        $url = 'https://tm.dwycloud.com/jbl/api/module-data/brand_in_stock/brand_in_stock/diy/1';
//        $url = 'https://tm.dwycloud.com/jbl/api/module-data/brand_in_stock/brand_in_stock/diy/lead_bind';
        $header = [
            'Content-Type:application/json',
            'Authorization: ' . $token,
        ];
        $lead_bind = $data['lead_bind'];
        $return_bind = $this->post_helper($url, json_encode($lead_bind), $header);
        $return_bind = json_decode($return_bind, true);

        //商标出库
//        $url = 'https://tm.dwycloud.com/jbl/api/module-data/brand_in_stock/brand_in_stock/diy/lead_bind_out_stock';
        $url = 'https://tm.dwycloud.com/jbl/api/module-data/brand_in_stock/brand_in_stock/diy/11';
        $lead_out = $result;
        $return_out = $this->post_helper($url, json_encode($lead_out), $header);
        $return_out = json_decode($return_out, true);

        //toDo
        BigKingCbj::where('id',$id)->update(['is_successful' => 1]);
    }

    public function post_helper($url, $data, $auth)
    {
        $header = [
            'Content-Type:application/json',
            'Authorization: ' . $auth,
        ];
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_TIMEOUT, 30);
        if (!is_null($data)) curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
        $r = curl_exec($ch);
        curl_close($ch);
        return $r;

    }
}
